<template>
    <div>
        <h1>Dropdown</h1>
        <div class="component">
            <cumulus-dropdown
                :id="id"
                :maxHeight="maxHeight"
                :multiselect="multiselect"
                :options="options"
                :placehodler="placeholder"
                :updatePlaceholderOnSelection="updatePlaceholderOnSelection"
                v-on:dropdownValueChanged="onEvent('dropdownValueChanged', $event)"
                v-on:dropdownMultiselectChanged="onEvent('dropdownMultiselectChanged', $event)" />
        </div>
        <div class="props">
            <h4>Props</h4>
            <div class="props-content">
                <div class="prop">
                    <label>:id</label>
                    <input type="text" v-model="id" />
                </div>
                <div class="prop">
                    <label>:maxHeight</label>
                    <input type="text" v-model="maxHeight" />
                </div>
                <div class="prop">
                    <input id="multiselect" type="checkbox" v-model="multiselect" />
                    <label for="multiselect" class="label">:multiselect</label>
                </div>
                <div class="prop">
                    <label>:placeholder</label>
                    <input type="text" v-model="placeholder" />
                </div>
                <div class="prop">
                    <label>:options</label>
                    <pre style="display: inline-block;">{{optionsArea}}</pre>
                </div>
                <div class="prop">
                    <input id="updatePlaceholderOnSelection"
                        type="checkbox"
                        v-model="updatePlaceholderOnSelection" />
                    <label for="updatePlaceholderOnSelection"
                        class="label">
                        :updatePlaceholderOnSelection
                    </label>
                </div>
            </div>
        </div>
        <div class="events" v-show="showEvents">
            <h4>Events</h4>
            <pre ref="eventText"></pre>
        </div>
    </div>
</template>

<script>
import CumulusDropdown from '../../components/dropdown/dropdown.vue';

export default {
    name: 'DropdownSandbox',

    components: { CumulusDropdown },

    props: {
        id: {
            type: String,
            default: 'my-dropdown',
        },
        maxHeight: {
            default: '100%',
            type: String,
        },
        multiselect: {
            default: false,
            type: Boolean,
        },
        placeholder: String,
        options: {
            type: Array,
            default: () => [
                { display: 'Option 1', selected: false, value: 'opt1' },
                { display: 'Option 2', selected: true, value: 'opt2' },
            ],
        },
        showEvents: {
            type: Boolean,
            default: false,
        },
        updatePlaceholderOnSelection: {
            default: true,
            type: Boolean,
        },
    },

    methods: {
        onEvent(name, event) {
            this.showEvents = true;
            const eventArea = this.$refs.eventText;
            eventArea.innerText = `${name} => ${JSON.stringify(event)}`;
        },
    },

    computed: {
        optionsArea() {
            return JSON.stringify(this.options, null, 4);
        },
    },
};

</script>
<style lang="scss">
.dropdown {
    border-style: solid;
    border-width: 1px;
}

.dropdown-options {
    border-style: solid;
    border-width: 1px;
}
</style>
